; simple tests of the expression evaluator

(load "s-evaluator.scm")

; takes two or more arguments.  displays the first two
; separated by =>, then all following separated by :.

(define (compare-values s u . v)
  (define (iter shrink)
    (if (not (null? shrink))
        (begin 
          (display " : ") 
          (display (car shrink))
          (iter (cdr shrink)))))
  (display s) (display " => ") (display u)
  (iter v)
  (newline))

(define a (make-exp '+ 1 2))                     ; 1+2=3
(define b (make-exp '* a 3))            ; (1+2)*3 = 9
(define c (make-exp '/ a (make-exp '+ 3 4)))  ; (1+2)/(3+4) = 3/7
(define d (make-exp '* c (make-exp '/ 1 c)))  ; c * (1/c) = 1
(define e '(+ 1 (* 2 3)))               ; (1+(2*3)) = 7
(define f '(+ 1 (* 2 (- 3 5))))         ; (1+(2*(3-5))) = -3
(define g '(^ 2 (* 2 2)))         ; (2^(2*2)) = 16

(compare-values a 3 (eval-expr a) (- 3 (eval-expr a)))      ; 1+2=3
(compare-values b 9 (eval-expr b) (- 9 (eval-expr b)) )     ; (1+2)*3 = 9
(compare-values c (/ 3 7) (eval-expr c) (- (/ 3 7) (eval-expr c)))  ; (1+2)/(3+4) = 3/7
(compare-values d 1 (eval-expr d) (- 1 (eval-expr d)))  ; c * (1/c) = 1
(compare-values e 7 (eval-expr e) (- 7 (eval-expr e)))  ; (1+(2*3)) = 7
(compare-values f -3 (eval-expr f) (- -3 (eval-expr f)))  ; (1+(2*(3-5))) = -3
(compare-values g 16 (eval-expr g) (- 16 (eval-expr g)))  ; (2^(2*2)) = 16

